searchNodes=[{"doc":"Csv schema is a library helping you to build Ecto schema-like files having as source a csv file. The idea behind this library is give the possibility to create, at compile-time, getters function for a CSV inside codebase. APIs related to this macro are similar to Ecto.Schema; Eg. defmodule Person do use Csv.Schema , headers : true , separator : ?, alias Csv.Schema.Parser schema path : &quot;path/to/person.csv&quot; do field :id , &quot;id&quot; , key : true field :first_name , &quot;first_name&quot; , filter_by : true field :last_name , &quot;last_name&quot; , sort : :asc field :identifier , [ &quot;first_name&quot; , &quot;last_name&quot; ] , key : true , join : &quot; &quot; field :email , &quot;email&quot; , unique : true field :gender , &quot;gender&quot; , filter_by : true , sort : :desc field :ip_address , &quot;ip_address&quot; field :date_of_birth , &quot;date_of_birth&quot; , parser : &amp; Parser . date! ( &amp;1 , &quot;{0M}/{0D}/{0YYYY}&quot; ) end end It is possible to define the schema with data: param in order to directly use a string to geerate content ... @content &quot;&quot;&quot; id,first_name,last_name,email,gender,ip_address,date_of_birth 1,Ivory,Overstreet,ioverstreet0@businessweek.com,Female,30.138.91.62,10/22/2018 2,Ulick,Vasnev,uvasnev1@vkontakte.ru,Male,35.15.164.70,01/19/2018 3,Chloe,Freemantle,cfreemantle2@parallels.com,Female,133.133.113.255,08/13/2018 &quot;&quot;&quot; schema data : @content do ... end At the end of compilation now your module is a Struct and has 3 kind of getters: by_{key_field_name} returns single records object or nil. filter_by_{field_name} returns list of records matching provided property. get_all returns all records Back to the example in the module will be created: __MODULE__.by_id/1 expecting integer as arg __MODULE__.filter_by_name/1 expecting string as arg __MODULE__.by_fiscal_code/1 expecting string as arg __MODULE__.get_all/0 Some example definitions could be found here","ref":"Csv.Schema.html","title":"Csv.Schema","type":"module"},{"doc":"separator it's possible to set a separator argument to macro to let the macro split csv for you using provided separator. header if your csv file does not have headers , it's possible to set headers to false and configure fields by index (1..N)","ref":"Csv.Schema.html#__using__/1","title":"Csv.Schema.__using__/1","type":"macro"},{"doc":"Configure a new field (csv column). Parameters are name - new struct field name column - header name or column index (if headers: false) in csv file opts - list of configuration values :key - boolean; at most one key must be set. It is something similar to a primary key :unique - boolean; creates a function by_{name} for you :filter_by - boolean; do i create a filter_by_{name} function for this field for you? :parser - function; parser function used to get_changeset data from string to custom type :sort - :asc or :desc ; It sorts according to Erlang's term ordering with nil exception :join - string; if present it joins the given fields into a binary using the separator","ref":"Csv.Schema.html#field/3","title":"Csv.Schema.field/3","type":"macro"},{"doc":"Schema macro helps you to build a block of fields. First parameter should be the relative path to csv file in your project. Second parameter should be a field list included in do - end block","ref":"Csv.Schema.html#schema/2","title":"Csv.Schema.schema/2","type":"macro"},{"doc":"","ref":"Csv.Schema.html#t:name/0","title":"Csv.Schema.name/0","type":"type"},{"doc":"","ref":"Csv.Schema.html#t:order/0","title":"Csv.Schema.order/0","type":"type"},{"doc":"","ref":"Csv.Schema.html#t:row/0","title":"Csv.Schema.row/0","type":"type"},{"doc":"Utility module containing some functions for parsing and to read CSV file.","ref":"Csv.Schema.Parser.html","title":"Csv.Schema.Parser","type":"module"},{"doc":"Having a string or an atom as input cast value to atom. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . atom! ( &quot;&quot; ) nil iex&gt; Csv.Schema.Parser . atom! ( nil ) nil iex&gt; Csv.Schema.Parser . atom! ( &quot;id&quot; ) :id iex&gt; Csv.Schema.Parser . atom! ( :id ) :id iex&gt; Csv.Schema.Parser . atom! ( 1 ) ** (RuntimeError) Cannot cast &#39;1&#39; to atom","ref":"Csv.Schema.Parser.html#atom!/1","title":"Csv.Schema.Parser.atom!/1","type":"function"},{"doc":"Having a string as input cast value to boolean. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . boolean! ( &quot;&quot; ) nil iex&gt; Csv.Schema.Parser . boolean! ( nil ) nil iex&gt; Csv.Schema.Parser . boolean! ( &quot;true&quot; ) true iex&gt; Csv.Schema.Parser . boolean! ( &quot;false&quot; ) false iex&gt; Csv.Schema.Parser . boolean! ( &quot;1a&quot; ) ** (RuntimeError) Cannot cast &#39;1a&#39; to boolean","ref":"Csv.Schema.Parser.html#boolean!/1","title":"Csv.Schema.Parser.boolean!/1","type":"function"},{"doc":"Given a CSV file path try to parse as CSV with headers. Use list of maps as data representation.","ref":"Csv.Schema.Parser.html#csv!/3","title":"Csv.Schema.Parser.csv!/3","type":"function"},{"doc":"Having a string as input representing string date to parse and a string representing the date format try to cast value to date. If something else is given or format is invalid or date is not parsable with given format an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . date! ( &quot;&quot; , &quot;whatever&quot; ) nil iex&gt; Csv.Schema.Parser . date! ( nil , &quot;whatever&quot; ) nil iex&gt; Csv.Schema.Parser . date! ( &quot;18/01/2019&quot; , &quot;{0D}/{0M}/{0YYYY}&quot; ) ~N[2019-01-18 00:00:00] iex&gt; Csv.Schema.Parser . date! ( &quot;18/01/2019&quot; , &quot;{0M}/{0D}/{0YYYY}&quot; ) ** (RuntimeError) Cannot cast &#39;18/01/2019&#39; to date with format &#39;{0M}/{0D}/{0YYYY}&#39; iex&gt; Csv.Schema.Parser . date! ( &quot;18/01/2019&quot; , &quot;MDY&quot; ) ** (RuntimeError) Invalid date format &#39;MDY&#39;","ref":"Csv.Schema.Parser.html#date!/2","title":"Csv.Schema.Parser.date!/2","type":"function"},{"doc":"Having a string as input cast value to float. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . float! ( &quot;&quot; ) nil iex&gt; Csv.Schema.Parser . float! ( nil ) nil iex&gt; Csv.Schema.Parser . float! ( &quot;1.2&quot; ) 1.2 iex&gt; Csv.Schema.Parser . float! ( &quot;1a&quot; ) ** (RuntimeError) Cannot cast &#39;1a&#39; to float","ref":"Csv.Schema.Parser.html#float!/1","title":"Csv.Schema.Parser.float!/1","type":"function"},{"doc":"Having a string as input cast value to integer. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . integer! ( &quot;&quot; ) nil iex&gt; Csv.Schema.Parser . integer! ( nil ) nil iex&gt; Csv.Schema.Parser . integer! ( &quot;1&quot; ) 1 iex&gt; Csv.Schema.Parser . integer! ( &quot;1a&quot; ) ** (RuntimeError) Cannot cast &#39;1a&#39; to integer","ref":"Csv.Schema.Parser.html#integer!/1","title":"Csv.Schema.Parser.integer!/1","type":"function"},{"doc":"Having a string or an atom as input cast value to string. If something else is given an exception is raised. If given argument is empty string or nil return value will be nil. Examples iex&gt; Csv.Schema.Parser . string! ( &quot;&quot; ) nil iex&gt; Csv.Schema.Parser . string! ( nil ) nil iex&gt; Csv.Schema.Parser . string! ( &quot;id&quot; ) &quot;id&quot; iex&gt; Csv.Schema.Parser . string! ( :id ) &quot;id&quot; iex&gt; Csv.Schema.Parser . string! ( 1 ) ** (RuntimeError) Cannot cast &#39;1&#39; to string","ref":"Csv.Schema.Parser.html#string!/1","title":"Csv.Schema.Parser.string!/1","type":"function"},{"doc":"MIT License Copyright (c) 2019 PrimaIt Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Csv Schema Csv schema is a library helping you to build Ecto.Schema-like modules having a csv file as source. The idea behind this library is give the possibility to create, at compile-time, a self-contained module exposing functions to retrieve data starting from a CSV.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding :csv_schema to your list of dependencies in mix.exs : def deps do [ { :csv_schema , &quot;~&gt; 0.2.8&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Supposing you have a CSV file looking like this: id | first_name | last_name | email | gender | ip_address | date_of_birth | :----|:-----------|:-----------|:------------------------------|:-------|:----------------|:--------------| 1 | Ivory | Overstreet | ioverstreet0@businessweek.com | Female | 30.138.91.62 | 10/22/2018 | 2 | Ulick | Vasnev | uvasnev1@vkontakte.ru | Male | 35.15.164.70 | 01/19/2018 | 3 | Chloe | Freemantle | cfreemantle2@parallels.com | Female | 133.133.113.255 | 08/13/2018 | ... | ... | ... | ... | ... | ... | ... | It is possible to create an Ecto.Schema-like repository using Csv.Schema macro: defmodule Person do use Csv.Schema alias Csv.Schema.Parser schema path : &quot;path/to/person.csv&quot; do field :id , &quot;id&quot; field :first_name , &quot;first_name&quot; , filter_by : true field :last_name , &quot;last_name&quot; , sort : :asc field :identifier , [ &quot;first_name&quot; , &quot;last_name&quot; ] , key : true , join : &quot; &quot; field :email , &quot;email&quot; , unique : true field :gender , &quot;gender&quot; , filter_by : true , sort : :desc field :ip_address , &quot;ip_address&quot; field :date_of_birth , &quot;date_of_birth&quot; , parser : &amp; Parser . date! ( &amp;1 , &quot;{0M}/{0D}/{0YYYY}&quot; ) end end It is possible to define the schema with string: param in order to directly use a string to generate content @data &quot;&quot;&quot; id,first_name,last_name,email,gender,ip_address,date_of_birth 1,Ivory,Overstreet,ioverstreet0@businessweek.com,Female,30.138.91.62,10/22/2018 2,Ulick,Vasnev,uvasnev1@vkontakte.ru,Male,35.15.164.70,01/19/2018 3,Chloe,Freemantle,cfreemantle2@parallels.com,Female,133.133.113.255,08/13/2018 &quot;&quot;&quot; schema data : @data do ... end Note that it's not a requirement to map all fields, but every field mapped must have a column in csv file. For example the following field configuration will result in a compilation error: field :id , &quot;non_existing_id&quot; , ... Schema could be configured using a custom separator (default is ?,) use Csv.Schema , separator : ?, Moreover it's possible to configure if csv file has or has not an header. Depending on header param value field config changes: # Default header value is `true` use Csv.Schema # Csv with header schema path : &quot;path/to/person.csv&quot; do field :id , &quot;id&quot; , key : true ... end # Csv without header. Note that field 1 is binded with the first csv column. use Csv.Schema , header : false # Index goes from 1 to N schema path : &quot;path/to/person.csv&quot; do field :id , 1 , key : true ... end Now Person module is a struct, defined like this: defmodule Person do defstruct id : nil , first_name : nil , last_name : nil , email : nil , gender : nil , ip_address : nil , date_of_birth : nil end This macro creates for you inside Person module those functions: def by_id ( integer_key ) , do : ... def filter_by_first_name ( string_value ) , do : ... def by_email ( string_value ) , do : ... def filter_by_gender ( string_value ) , do : ... def get_all , do : ... Where: by_id returns a %Person{} or nil if key is not mapped in csv filter_by_first_name returns a [%Person{}, %Person{}, ...] or [] if input predicate does not match any person by_email returns a %Person{} or nil if no person have provided email in csv filter_by_gender returns a [%Person{}, %Person{}, ...] or [] if input predicate does not match any person gender get_all return all csv rows as a Stream","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Every field should be formed like this: field { struct_field } , { csv_header } , { opts } where: {struct_field} will be the struct field name. Could be configured as string or as atom {csv_header} is the csv column name from where get values. Must be configured using string only {opts} is a keyword list containing special configurations opts: :key : boolean. At most one key could be set. If set to true creates the by_{name} function for you. :unique : boolean. If set to true creates the by_{name} function for you. All csv values must be unique or an exception is raised :filter_by : boolean. If set to true creates the filter_by_{name}  function :parser : function. An arity 1 function used to map values from string to a custom type :sort : :asc or :desc . It sorts according to Erlang's term ordering with nil exception ( number &lt; atom &lt; reference &lt; fun &lt; port &lt; pid &lt; tuple &lt; list &lt; bit-string &lt; nil ) :join : string. If present it joins the given fields into a binary using the separator Note that every configuration is optional","ref":"readme.html#field-configuration","title":"Overview - Field configuration","type":"extras"},{"doc":"Compilation time increase in an exponential manner if csv contains lots of lines and you configure multiple fields candidate for method creation (flags key , unique and/or filter_by set to true). Because &quot;without data you're just another person with an opinion&quot; here some data: Compilation time csv rows key unique filter_by compile time 1_000 false 0 0 301_727 µs 1_000 false 2 0 352_522 µs 1_000 false 0 4 318_225 µs 1_000 true 0 0 334_240 µs 1_000 true 1 1 348_697 µs 1_000 true 2 0 406_367 µs 1_000 true 0 4 385_850 µs 1_000 true 2 2 414_617 µs 1_000 true 2 4 446_155 µs 5_000 false 0 0 2_734_565 µs 5_000 false 2 0 3_450_438 µs 5_000 false 0 4 3_464_593 µs 5_000 true 0 0 3_084_923 µs 5_000 true 1 1 3_795_718 µs 5_000 true 2 0 3_752_112 µs 5_000 true 0 4 3_387_067 µs 5_000 true 2 2 3_839_068 µs 5_000 true 2 4 4_113_228 µs 10_000 false 0 0 6_889_505 µs 10_000 false 2 0 8_667_683 µs 10_000 false 0 4 8_606_961 µs 10_000 true 0 0 7_892_421 µs 10_000 true 1 1 8_449_838 µs 10_000 true 2 0 9_507_693 µs 10_000 true 0 4 10_339_080 µs 10_000 true 2 2 10_518_744 µs 10_000 true 2 4 10_480_884 µs Execution time csv rows key unique filter_by by avg by tot filter_by avg filter_by tot 1_000 true 1 1 0.74 µs/op 74_412 µs 0.89 µs/op 89_275 µs 5_000 true 1 1 0.79 µs/op 79_776 µs 1.18 µs/op 118_786 µs 10_000 true 1 1 0.78 µs/op 78_908 µs 1.83 µs/op 183_642 µs Execution details Executed on my machine: Lenovo Thinkpad T480 CPU : Intel ( R ) Core ( TM ) i7 - 8550 U CPU @ 1.80 GHz RAM : 32 GB Try yourself If you like to run compilation benchmarks yourself: iex -S mix c &quot;benchmark/timings.exs&quot;","ref":"readme.html#keep-in-mind","title":"Overview - Keep in mind","type":"extras"},{"doc":"Copyright (c) 2019 PrimaIt This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]